import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import jp.hozo.core.Concept;
import jp.hozo.core.Ontology;
import jp.hozo.core.RoleHolder;
import jp.hozo.core.Slot;
import jp.hozo.core.WholeConcept;
import jp.hozo.corex.HZOntology;
import jp.hozo.corex.HZSlot;
import jp.hozo.corex.HZWholeConcept;
import jp.hozo.test.TestTimer;

/**
 * 
 * f[^Lqp萫lϊvO
 * 
 * @author enegate
 */
public class EQ2EAV {

	/* ϊʃt@Cw */
	private static String RESULT_FILE_NAME = "result.txt";
	FileOutputStream resultFile;
	OutputStreamWriter resultWriter;

	/* p[T[w */
	private static int DEFAULT_PARSER = Ontology.SAX_PARSER;

	/* [TERM] */
	private static String TERM_VALUE = "[TERM]";
	
	/* MP_ID */
	private static String MP_ID= "id: MP:";

	private static String PATO_ID_UNDERLINE= "PATO_";
	
	/* INTER_SECTION */
	private static String INTER_SECTION = "intersection_of:";
	
	private static int CANVAS_SIZE_WIDTH = 2276;
	private static int CANVAS_SIZE_HEIGHT = 2198;

	/* QƃIgW[̐ */
	protected HZOntology ontRef;
	
	/* Ǎf[^Xg */
	List<Term> dataList = new ArrayList<Term>();

	/* Ώۃf[^Zbg1 */
	protected Map<String,String[]> data_set1;

	/* Ώۃf[^Zbg2 */
	protected Map<String,String[]> data_set2;

	/* Ώۃf[^Zbg3 */
	protected Map<String,String[]> data_set3;

	/* ̓f[^1 */
	protected List<String[]> input_data1;

	/* ̓f[^2 */
	protected List<String[]> input_data2;

	/* dL[f[^Zbgɒǉ邽߂̎} */
	private int multiCnt = 0;
	
	/* o̓t@C */
	protected String fileName = "";
	
	/*  */
	protected String species = "";
	
	/*  */
	protected static Concept speciesConcept = null;

	/* 햼 */
	public static final String ANIMAL = "animal";

	/**
	 * 
	 * CNX
	 * <pre>
	 * EQ2EAV [Ή\] [QƃIgW[] [o̓IgW[] []Ŏs
	 * ϊłȂf[^́uresult.txtvɏo
	 * </pre>
	 * 
	 * @param args 
	 */
	public static void main(String[] args) {
		EQ2EAV tr = new EQ2EAV();

		// QƃIgW[t@C̓Ǎ
		tr.data_set1 = new TreeMap<String, String[]>();
		tr.data_set2 = new TreeMap<String, String[]>();
		tr.data_set3 = new TreeMap<String, String[]>();
		// inputf[^Xg
		tr.input_data1 = new ArrayList<String[]>();
		tr.input_data2 = new ArrayList<String[]>();
		
		// QƃIgW[쐬
		tr.ontRef = new HZOntology();

		// `FbN
		if (args.length < 4 || args.length > 4) {
			System.out.println("Use: EQ2EAV [Ή\] [QƃIgW[] [o̓IgW[] []");
			return;			
		}

		// ʃt@CXg[
		try {
			tr.resultFile = new FileOutputStream(RESULT_FILE_NAME);
			tr.resultWriter = new OutputStreamWriter(tr.resultFile, "utf-8");	
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
		TestTimer timer = new TestTimer();
		timer.start();
		
		// Ή\Ǎ
		if (args[0] != null) {
			System.out.println("------- step[1]:Ή\Ǎ --------");
			tr.loadData(args[0]);
		} else {
			System.out.println("Ή\t@Cw肵ĂB");
		}

		// QƃIgW[t@C̎w
		if (args[1] != null) {
			tr.ontRef.setSource(args[1]);
		} else {
			System.out.println("QƃIgW[t@Cw肵ĂB");
		}
		
		// o̓IgW[t@C̎w
		if (args[2] != null) {
			tr.fileName = args[2];
		} else {
			System.out.println("ۑIgW[t@Cw肵ĂB");
		}
		
		// o̓IgW[t@C̎w
		if (args[3] != null) {
			tr.species = args[3];
		} else {
			System.out.println("w肵ĂB");
		}

		try {
			System.out.println("------- step[2]:QƃIgW[Ǎ -------");
			tr.ontRef.load(DEFAULT_PARSER);
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
		
		// 쐬
		System.out.println("------- step[3]:𐶐 -------");
		speciesConcept = createSpecies(tr, tr.ontRef, tr.species);
		if (speciesConcept == null) {
			return;
		}
		
		// ύXIgW[쐬
		// DoubleTOo
		System.out.println("------- step[4]:doubleo -------");
		tr.outputInputdataDouble();
		// TripleTOo
		System.out.println("------- step[5]:tripleo -------");
		tr.outputInputdataTriple();
		// DoubleʊTOo
		System.out.println("------- step[6]:double  EAVɕϊ -------");
		tr.outputResultDouble();
		// TripleʊTOo
		System.out.println("------- step[7]:triple  EAVɕϊ -------");
		tr.outputResultTriple();
		// I^Oo
		tr.outputFooter();

		// ϊIgW[t@Cۑ
		System.out.println("------- step[8]:IgW[o͏ -------");
		//System.out.println("[Save Ontology]");
		if (tr.fileName != null) {
			tr.ontRef.setSource(tr.fileName);
		} else {
			return;
		}

		try {
			if (tr.fileName != null) {
				if (tr.fileName.endsWith(".ont")) {
					tr.ontRef.saveWithDependency(true);
				} else {
					tr.ontRef.save("UTF-8");
				}
			}
			System.out.println("t@Cu" + tr.ontRef.getSource() + "vŕۑ܂B");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}

		timer.stop();
		// ʃt@CXg[N[Y
		try {
			tr.resultWriter.close();
			tr.resultFile.close();
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}
	
	/**
	 * 
	 * TO𐶐
	 * 
	 * @param ont IgW[w
	 * @param speciesName ̖Ow
	 * @return TO߂܂B
	 */
	protected static Concept createSpecies(EQ2EAV eq2eav, HZOntology ont, String speciesName) {
		Concept specCon = null;
		if (ont != null) {
			specCon = ont.findWholeConceptByLabel(speciesName);
			if (specCon == null) {
				System.out.println(" \"" + speciesName + "\" ܂ł");
				eq2eav.resultWrite(" \"" + speciesName + "\" ܂ł");
			}
			
// Vɐ𐶐
//			if (specCon == null) {
//				// TO
//				Concept animalCon = ont.findWholeConceptByLabel(ANIMAL);
//			
//				// TO𐶐
//				specCon = ont.createConcept(WholeConcept.CONCEPT_TYPE, getNewConceptName(ont, speciesName, WholeConcept.CONCEPT_TYPE), "");
//				// ̉ʊTOƂĐݒ
//				ont.createIsaRelation(animalCon, specCon);
//			}
		}

		return specCon;
	}
	
	/**
	 * 
	 * ReLXg̑l𐶐
	 * 
	 * @param specCon TOw
	 * @param contextCon ReLXgTOw
	 * @return Xbg߂܂B
	 */
	private Slot createSpeciesValue(Concept specCon, Concept contextCon) {
		Slot rtnSlot = null;
		if (this.ontRef != null && specCon != null) {
			// ReLXgXbgꉻ
			if (contextCon != null && contextCon instanceof RoleHolder) {
				Slot depSlot = ((RoleHolder) contextCon).getDependentSlot();
				if (depSlot != null) {
					Concept depCon = depSlot.getOwnerConcept();
					// Xbgǉ
					String newRHName = depCon.getLabel() + " in " + specCon.getLabel();
					Concept existedCon = this.ontRef.findConceptByLabel(newRHName, RoleHolder.CONCEPT_TYPE);
					Slot specSlot = null;
					if (existedCon != null) {
						specSlot = ((RoleHolder) existedCon).getDependentSlot();
					} else {
						specSlot = ((HZWholeConcept) specCon).createAttributeOfSlot("distribution related quality", newRHName, "1", depCon.getLabel(), "");
					}
					// ꉻXbgǉ
					String newSubRHName = depSlot.getRoleHolderName() + " in " + specCon.getLabel();
					Concept existedSubCon = this.ontRef.findConceptByLabel(newSubRHName, RoleHolder.CONCEPT_TYPE);
					if (existedCon == null || existedSubCon == null) {
						Slot subSpecSlot = ((HZSlot) specSlot).createOverrideSlot(depSlot, false);
						if (subSpecSlot != null) {
							if (existedSubCon != null) {
								newSubRHName = getNewConceptName(this.ontRef, newSubRHName, RoleHolder.CONCEPT_TYPE, 1);
							}
							subSpecSlot.setRoleHolderName(newSubRHName);
							rtnSlot = subSpecSlot;
						}
					} else if (existedSubCon != null) {
						rtnSlot = ((RoleHolder) existedSubCon).getDependentSlot();
					}
				}
			}
		}
		return rtnSlot;
	}
	
	/**
	 * 
	 * d̂ȂTO擾
	 * 
	 * @param ont IgW[w
	 * @param name TOw
	 * @param conceptType TO^Cvw
	 * @return TO߂܂B
	 */
	public static String getNewConceptName(Ontology ont, String name, int conceptType) {
		return getNewConceptName(ont, name, conceptType, 0);
	}
	private static String getNewConceptName(Ontology ont, String name, int conceptType, int index) {
		String newName = name;
		int newIndex = index;
		if (newIndex > 0) {
			newName = name + "_" + newIndex;
		}
		
		if (ont != null) {
			Concept chkCon = ont.findConceptByLabel(newName, conceptType);
			if (chkCon != null) {
				return getNewConceptName(ont, name, conceptType, newIndex + 1);
			}
		} else {
			return "";
		}
		return newName;
	}

	/**
	 * 
	 * ̓f[^Double\o͂
	 *
	 */
	protected void outputInputdataDouble() {
		this.resultWrite("\n" + "[doublȅΏۊOf[^]" + "\n");
		
		// o̓f[^Xg
		List<String[]> inputData1 = this.input_data1;
		Concept parentConcept = this.ontRef.findConceptByLabel("E_P_1", WholeConcept.CONCEPT_TYPE);
		// E_P_1TO݂ȂꍇA쐬
		if (parentConcept == null) {
			parentConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "E_P_1", "");
			// Xbg쐬l
			Slot slot = ((HZWholeConcept) parentConcept).createPartOfSlot("form", "", "1", "double_1", "");
			// TuXbg
			((HZSlot) slot).createPartOfSlot("object", "", "1", "*entity", "");
			((HZSlot) slot).createPartOfSlot("property", "", "1", "property", "");
		}
		// triple1o
		for (String[] inputData : inputData1) {
			try {
				String triple = inputData[0];
				// TO쐬
				/** triple1 */
				Concept wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "EP_" + triple + "_1", "");
				// Xbg쐬
				Slot slot = ((HZWholeConcept) wConcept).createPartOfSlot("form", "", "1..", "double_" + triple, "");
				// eXbgw
				if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
					Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
					slot.setInheritedSlot(parentSlot);
				}				
					
				// is-a֌W𐶐
				this.ontRef.createIsaRelation(parentConcept, wConcept);
			} catch (Exception e) {
				System.out.println(inputData[0] + " : E_P_1𐳂쐬ł܂ł");
				this.resultWrite(inputData[0] + ", E_P_1𐳂쐬ł܂ł\n");
			}
		}
		
		parentConcept = this.ontRef.findConceptByLabel("double_1", WholeConcept.CONCEPT_TYPE);
		// double_1TO݂ȂꍇA쐬
		if (parentConcept == null) {
			parentConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "double_1", "");
			((HZWholeConcept) parentConcept).createPartOfSlot("first", "", "1", "Any", "");
			((HZWholeConcept) parentConcept).createPartOfSlot("second", "", "1", "Any", "");
		}
		// double_epo
		for (String[] inputData : inputData1) {
			try {
				String triple = inputData[0];
				String entity = inputData[1];
				String pato = inputData[2];
				// TO쐬
				/** triple1 */
				Concept wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "double_" + triple, "");
				// XbgP쐬
				Slot slot = ((HZWholeConcept) wConcept).createPartOfSlot("first", "", "1", "*" + entity, "");
				// eXbgw
				if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
					Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
					slot.setInheritedSlot(parentSlot);
				}
	
				// XbgQ쐬
				slot = ((HZWholeConcept) wConcept).createPartOfSlot("second", "", "1", pato, "");
				// eXbgw
				if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null && parentConcept.getPartOfSlotList().size()>1) {
					Slot parentSlot = parentConcept.getPartOfSlotList().get(1);
					slot.setInheritedSlot(parentSlot);
				}
				
				// is-a֌W𐶐
				this.ontRef.createIsaRelation(parentConcept, wConcept);
			} catch (Exception e) {
				System.out.println(inputData[0] + " : double_1𐳂쐬ł܂ł");
				this.resultWrite(inputData[0] + ", double_1𐳂쐬ł܂ł\n");
			}
		}
	}

	/**
	 * 
	 * ̓f[^Triple\o͂
	 *
	 */
	protected void outputInputdataTriple() {
		this.resultWrite("\n" + "[triplȅΏۊOf[^]" + "\n");
		
		// o̓f[^Xg
		List<String[]> inputData2 = this.input_data2;
		
		Concept parentConcept = this.ontRef.findConceptByLabel("E_P_P_1", WholeConcept.CONCEPT_TYPE);
		// E_P_P_1TO݂ȂꍇA쐬
		if (parentConcept == null) {
			parentConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "E_P_P_1", "");
			Slot slot = ((HZWholeConcept) parentConcept).createPartOfSlot("form", "", "1", "triple_2", "");
			// TuXbgP
			Slot subSlot = ((HZSlot) slot).createPartOfSlot("first", "", "1", "*entity", "");
			//eXbgݒ
			subSlot.setInheritedSlot(slot);
			// TuXbgQ
			subSlot = ((HZSlot) slot).createPartOfSlot("second", "", "1", "property", "");
			//eXbgݒ
			subSlot.setInheritedSlot(slot);
			// TuXbgR
			subSlot = ((HZSlot) slot).createPartOfSlot("third", "", "1", "property", "");
			//eXbgݒ
			subSlot.setInheritedSlot(slot);
		}
		// EPP_triple_1
		for (String[] inputData : inputData2) {
			try {
				String triple = inputData[0];
				// TO쐬
				/** triple1 */
				Concept wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "EPP_" + triple + "_1", "");
				// Xbg쐬
				Slot slot =  ((HZWholeConcept) wConcept).createPartOfSlot("form", "", "1", "EPP_triple_" + triple, "");
				// eXbgw
				if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
					Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
					slot.setInheritedSlot(parentSlot);
				}
				// is-a֌W𐶐
				this.ontRef.createIsaRelation(parentConcept, wConcept);
			} catch (Exception e) {
				System.out.println(inputData[0] + " : E_P_P_1𐳂쐬ł܂ł");
				this.resultWrite(inputData[0] + ", E_P_P_1𐳂쐬ł܂ł\n");
			}
		}
		
		parentConcept = this.ontRef.findConceptByLabel("triple_2", WholeConcept.CONCEPT_TYPE);
		// triple_2TO݂ȂꍇA쐬
		if (parentConcept == null) {
			parentConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "triple_2", "");
			// Xbg쐬
			((HZWholeConcept) parentConcept).createPartOfSlot("first", "", "1", "Any", "");
			// Xbg쐬
			((HZWholeConcept) parentConcept).createPartOfSlot("second", "", "1", "Any", "");
			// Xbg쐬
			((HZWholeConcept) parentConcept).createPartOfSlot("third", "", "1", "Any", "");
		}
		// EPP_triple_tripleo
		for (String[] inputData : inputData2) {
			try {
				String triple = inputData[0];
				String entity = inputData[1];
				// TO쐬
				/** triple1 */
				Concept wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "EPP_triple_" + triple, "");
				// XbgP쐬
				Slot slot = ((HZWholeConcept) wConcept).createPartOfSlot("first", "", "1", "*" + entity, "");
				// eXbgw
				if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
					Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
					slot.setInheritedSlot(parentSlot);
				}
				// XbgQ쐬
				slot = ((HZWholeConcept) wConcept).createPartOfSlot("second", "", "1", inputData[2], "");
				// eXbgw
				if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null && parentConcept.getPartOfSlotList().size()>1) {
					Slot parentSlot = parentConcept.getPartOfSlotList().get(1);
					slot.setInheritedSlot(parentSlot);
				}
				// XbgR쐬
				slot = ((HZWholeConcept) wConcept).createPartOfSlot("third", "", "1", inputData[3], "");
				// eXbgw
				if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null && parentConcept.getPartOfSlotList().size()>2) {
					Slot parentSlot = parentConcept.getPartOfSlotList().get(2);
					slot.setInheritedSlot(parentSlot);
				}
					
				// is-a֌W𐶐
				this.ontRef.createIsaRelation(parentConcept, wConcept);
			} catch (Exception e) {
				System.out.println(inputData[0] + " : triple_2𐳂쐬ł܂ł");
				this.resultWrite(inputData[0] + ", triple_2𐳂쐬ł܂ł\n");
			}
		}
	}

	/**
	 * 
	 * Double\EAV\o͂
	 *
	 */
	protected void outputResultDouble() {
		// f[^擾
		Concept eavConcept = this.ontRef.findConceptByLabel("E_A_V_1", WholeConcept.CONCEPT_TYPE);
		// E_A_V_1TO݂ȂꍇA쐬
		if (eavConcept == null) {
			eavConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "E_A_V_1", "");
		}
		
		this.resultWrite("\n" + "[double  E_A_V̏ΏۊOf[^]" + "\n");
		
		Concept parentConcept = this.ontRef.findConceptByLabel("triple_1", WholeConcept.CONCEPT_TYPE);
		// triple_1TO݂ȂꍇA쐬
		if (parentConcept == null) {
			parentConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "triple_1", "");
			Slot slot = ((HZWholeConcept) parentConcept).createPartOfSlot("form", "", "1", "triple_1", "");
			// TuXbg
			((HZSlot) slot).createPartOfSlot("object", "", "1", "*entity", "");
			((HZSlot) slot).createPartOfSlot("attribute", "", "1", "#quality_1", "");
			((HZSlot) slot).createPartOfSlot("value", "", "1", "represented quantity | qualitative quantity | number | categorical | #entity", "");
		}
		
		// LbV
		Map<String, String[]> mapDouble = new LinkedHashMap<String, String[]>();
		
		// TRIPLE_EAV
		for (String[] data : this.input_data1) {				
			String triple = data[0];
			String entity = data[1];
			String attribute = data[2];
			String value = "";
			
			// TO̎QƐ̒l擾
			Slot depSlot = null;
			Concept attributeCon = null;
			String[] keyValues;
			// ɌʃLbVɂ邩`FbN
			if (!mapDouble.containsKey(attribute)) {
				attributeCon = this.ontRef.findWholeConceptByLabel(attribute);
				if (attributeCon != null) {
					// l̎QƃXbg擾
					Slot refSlot = getReferringToSlot(attributeCon, false);
					if (refSlot != null && refSlot.getConstraintConcept() != null
							&& refSlot.getConstraintConcept() instanceof RoleHolder) {
						// l擾
						value = refSlot.getConstraintConceptLabel();
						/// TO擾
						depSlot = ((RoleHolder) refSlot.getConstraintConcept()).getDependentSlot();
						Concept orgCon = depSlot.getConstraintConcept();
						if (orgCon != null) {
							String attributeValue = getReferringSlotValue(orgCon);
							if (attributeValue != null) {
								attribute = attributeValue;
							} else {
								attribute = null;
							}
						} else {
							attribute = null;
						}
					} else {
						value = null;
					}
				} else {
					value = null;
				}
				keyValues = new String[2];
				keyValues[0] = attribute;
				keyValues[1] = value;
				mapDouble.put(data[2], keyValues);
			} else {
				keyValues = mapDouble.get(data[2]);
			}
			
			if (keyValues != null) {
				value = keyValues[1];
				if (value == null) {
					System.out.println(triple + " : l܂ł(double)");
					this.resultWrite(triple + ", l܂ł(double)\n");
					continue;
				}
				attribute = keyValues[0];
				if (attribute == null) {
					System.out.println(triple + " : ܂ł(double)");
					this.resultWrite(triple + ", ܂ł(double)\n");
					continue;
				}
			} else {
				System.out.println(triple + " : f[^܂ł(double)");
				this.resultWrite(triple + ", f[^܂ł(double)\n");
				continue;
			}
			
			// TO쐬
			/** TRIPLE_EAV */
			Concept wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "triple_" + triple, "");
			// Termf[^ݒ
			String desc = this.getDescription(data);
			wConcept.setDescription(desc);
			// XbgP쐬
			Slot slot = ((HZWholeConcept) wConcept).createPartOfSlot("first", "", "1", "*" + entity, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
				slot.setInheritedSlot(parentSlot);
			}
			// XbgQ쐬
			slot = ((HZWholeConcept) wConcept).createPartOfSlot("second", "", "1", attribute, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null && parentConcept.getPartOfSlotList().size()>1) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(1);
				slot.setInheritedSlot(parentSlot);
			}
			// XbgR쐬
			Slot tmpSlot = ((HZWholeConcept) wConcept).createPartOfSlot("third", "", "1", value, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null && parentConcept.getPartOfSlotList().size()>2) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(2);
				tmpSlot.setInheritedSlot(parentSlot);
			}
			
			// is-a֌W𐶐
			this.ontRef.createIsaRelation(parentConcept, wConcept);
			
			
			/** triple1 */
			wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "EAV_" + triple + "_1", "");
			// Xbg쐬
			slot = ((HZWholeConcept) wConcept).createPartOfSlot("form", "", "1", "triple_" + triple, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
				slot.setInheritedSlot(parentSlot);
			}
			// is-a֌W𐶐
			this.ontRef.createIsaRelation(eavConcept, wConcept);
			
			// ReLXgl쐬
			if (depSlot != null && depSlot.isSetRoleHolder()) {
				Slot specContextSlot = createSpeciesValue(speciesConcept, depSlot.getRoleHolder());
				tmpSlot.setConstraintConcept(specContextSlot.getRoleHolder());
				tmpSlot.setSlotConstraintConceptLabel(specContextSlot.getRoleHolderName());
			}
		}
	}

	/**
	 * 
	 * Triple\EAV\o͂
	 *
	 */
	protected void outputResultTriple() {
		// f[^Xg쐬
		this.resultWrite("\n" + "[triple  E_A_V̏ΏۊOf[^]" + "\n");
		
		Concept eavConcept = this.ontRef.findConceptByLabel("E_A_V_1", WholeConcept.CONCEPT_TYPE);
		// E_A_V_1TO݂ȂꍇA쐬
		if (eavConcept == null) {
			eavConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "E_A_V_1", "");
		}
		
		// eXbg擾
		Concept parentConcept = this.ontRef.findConceptByLabel("triple_1", WholeConcept.CONCEPT_TYPE);
		// triple_1TO݂ȂꍇA쐬
		if (parentConcept == null) {
			parentConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "triple_1", "");
			((HZWholeConcept) parentConcept).createPartOfSlot("first", "", "1", "Any", "");
			((HZWholeConcept) parentConcept).createPartOfSlot("second", "", "1", "Any", "");
			((HZWholeConcept) parentConcept).createPartOfSlot("third", "", "1", "Any", "");
		}
		
		// LbV
		Map<String, String> mapTripleAttribute = new LinkedHashMap<String, String>();
		Map<String, String> mapTripleValue = new LinkedHashMap<String, String>();
		
		// TRIPLE_EAV
		for (String[] data : this.input_data2) {
			String triple = data[0];
			String entity = data[1];
			String attribute = data[2];
			String value = data[3];
			
			// ɌʃLbVɂ邩`FbN
			if (!mapTripleAttribute.containsKey(data[2])) {
				Concept attributeCon = this.ontRef.findWholeConceptByLabel(attribute);
				if (attributeCon != null) {
					// TO̎QƃXbg擾
					Slot refSlot = getReferringToSlot(attributeCon, true);
					if (refSlot != null) {
						attribute = getReferringSlotValue(refSlot);
					} else {
						attribute = null;
					}
				} else {
					attribute = null;
				}
				mapTripleAttribute.put(data[2], attribute);
			} else {
				attribute = mapTripleAttribute.get(data[2]);
			}
			if (attribute == null) {
				System.out.println(triple + " : ܂ł(triple)");
				this.resultWrite(triple + ", ܂ł(triple)\n");
				continue;
			}
			
			// l擾
			if (!mapTripleValue.containsKey(data[3])) {
				Concept valueCon = this.ontRef.findWholeConceptByLabel(value);
				if (valueCon != null) {
					// l̎QƃXbg擾
					Slot valSlot = getReferringToSlot(valueCon, false);
					if (valSlot != null) {
						//value = valSlot.getConstraintConceptLabel();
						value = valSlot.getSlotConstraintConceptLabel();
					} else {
						value = null;
					}
				} else {
					value = null;
				}
				mapTripleAttribute.put(data[3], value);
			} else {
				value = mapTripleValue.get(data[3]);
			}
			if (value == null) {
				System.out.println(triple + " : l܂ł(triple)");
				this.resultWrite(triple + ", l܂ł(triple)\n");
				continue;
			}
			
			// TO쐬
			/** TRIPLE_EAV */
			Concept wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "triple_" + triple, "");
			// Termf[^ݒ
			String desc = this.getDescription(data);
			wConcept.setDescription(desc);
			// XbgP쐬
			Slot slot = ((HZWholeConcept) wConcept).createPartOfSlot("first", "", "1", "*" + entity, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
				slot.setInheritedSlot(parentSlot);
			}
			// XbgQ쐬
			slot = ((HZWholeConcept) wConcept).createPartOfSlot("second", "", "1", attribute, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null && parentConcept.getPartOfSlotList().size()>1) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(1);
				slot.setInheritedSlot(parentSlot);
			}
			// XbgR쐬
			slot = ((HZWholeConcept) wConcept).createPartOfSlot("third", "", "1", value, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null && parentConcept.getPartOfSlotList().size()>2) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(2);
				slot.setInheritedSlot(parentSlot);
			}
			// is-a֌W𐶐
			this.ontRef.createIsaRelation(parentConcept, wConcept);
			
			
			wConcept = this.ontRef.createConcept(WholeConcept.CONCEPT_TYPE, "EAV_" + triple + "_1", "");
			// Xbg쐬
			slot = ((HZWholeConcept) wConcept).createPartOfSlot("form", "", "1", "triple_" + triple, "");
			// eXbgw
			if (parentConcept!=null && parentConcept.getPartOfSlotList()!=null) {
				Slot parentSlot = parentConcept.getPartOfSlotList().get(0);
				slot.setInheritedSlot(parentSlot);
			}
			// is-a֌W𐶐
			this.ontRef.createIsaRelation(eavConcept, wConcept);
		}
	}
	
	/**
	 * 
	 * TO̎QƐ̊TO擾
	 *
	 * @param con TOw
	 * @param checkClassConst NX`FbN邩ǂw
	 * @return YXbg߂܂B
	 */
	private Slot getReferringToSlot(Concept con, boolean checkClassConst) {
		Slot refSlot = null;
		if (con != null) {
			List<Slot> refSlots = con.findSlotsByRoleName("referring to");
			if (refSlots == null || refSlots.isEmpty()) {
				refSlots = con.findSlotsByRoleName("referring to 2");
			}
			if (refSlots != null && !refSlots.isEmpty()) {
				refSlot = refSlots.get(0);
				if (checkClassConst && refSlot.getConstraintConcept() instanceof RoleHolder) {
					if (con.getUpperConcept() != null
							&& !con.getUpperConcept().getLabel().equals("property")) {
						refSlot = getReferringToSlot(con.getUpperConcept(), checkClassConst);
					} else {
						refSlot = null;
					}
				}
			} else if (con.getUpperConcept() != null
					&& !con.getUpperConcept().getLabel().equals("property")) {
				refSlot = getReferringToSlot(con.getUpperConcept(), checkClassConst);
			}
		}
		return refSlot;
	}
	
	/**
	 * 
	 * TO̎QƐ̊TO擾
	 *
	 * @param slot Xbgw
	 * @return Yl߂܂B
	 */
	private String getReferringSlotValue(Slot slot) {
		String refStr = "";
		if (slot != null && slot.getConstraintConcept() != null) {
			Concept constCon = slot.getConstraintConcept();
			List<Slot> valueSlots = constCon.findSlotsByRoleName("value of");
			if (valueSlots != null && !valueSlots.isEmpty()) {
				//refStr = valueSlots.get(0).getConstraintConceptLabel();
				refStr = valueSlots.get(0).getSlotConstraintConceptLabel();
				if (!refStr.startsWith("#")) {
					refStr = "#" + refStr;
				}
			} else {
				refStr = getReferringSlotValue(constCon);
			}
		}
		return refStr;
	}
	
	/**
	 * 
	 * TO̎QƐ̊TO擾
	 *
	 * @param con TOw
	 * @return Yl߂܂B
	 */
	private String getReferringSlotValue(Concept con) {
		String refStr = "";
		List<Slot> valueSlots = con.findSlotsByRoleName("value of");
		if (valueSlots != null && !valueSlots.isEmpty()) {
			refStr = valueSlots.get(0).getSlotConstraintConceptLabel();
			if (!refStr.startsWith("#")) {
				refStr = "#" + refStr;
			}
		} else {
			if (con.getUpperConcept() != null
					&& !con.getUpperConcept().getLabel().equals("quantity")) {
				refStr = getReferringSlotValue(con.getUpperConcept());
			}
		}
		return refStr;
	}

	/**
	 * 
	 * I^Oo
	 * 
	 */
	protected void outputFooter() {
		this.ontRef.getGraphics().setRelationCanvasSize(CANVAS_SIZE_WIDTH, CANVAS_SIZE_HEIGHT);
	}

	/**
	 * 
	 * OBO`̑Ή\ǍAf[^Zbgݒ肷
	 * 
	 * @param Ή\t@C
	 */
	protected void loadData(String mappingFileName) {
		// Ή\t@CǍ
		try{
			FileReader fr = null;
			BufferedReader br;
			fileName = mappingFileName;
			if (mappingFileName != null) {
	            fr = new FileReader(mappingFileName);
			} else {
				System.out.println("Ή\t@Cw肵ĂB");
			}
            br = new BufferedReader(fr);
        
            // [Term]Ǎ݁A͂ăf[^Zbgɐݒ
			this.resultWrite("\n" + "[Ή\̏ΏۊOf[^]" + "\n");
            String tmp_str;
            Term term = null;
            List<Property> properties = null;
            Property property = null;
    		// ^C}[Jn
    		TestTimer timer = new TestTimer();
    		timer.start();
    		int dataCnt = 0;
            while((tmp_str = br.readLine()) != null){
            	if (tmp_str.startsWith("!")) {
            		// ΏۊOf[^ʃt@Cɏo
            		if (tmp_str.indexOf("id: MP:") > 0) {
            			//String errorId = tmp_str.substring(tmp_str.indexOf("!"));
            			int index = tmp_str.indexOf("id: MP:");
            			String errorId = tmp_str.substring(index + 3, index + 14).trim();
            			System.out.println(errorId + " : ΏۊOf[^");
            			this.resultWrite(errorId + ", ΏۊOf[^" + "\n");
            		}
            		continue;
            	}
            	// [TERM]̏ꍇAf[^ϐ
            	if (tmp_str.equalsIgnoreCase(TERM_VALUE)) {
            		// TERMf[^Xgɒǉ
            		setTerm(term, properties);
            		term = new Term();
            		properties = new ArrayList<Property>();
                	dataCnt++;
            	} else if (tmp_str.indexOf(MP_ID) >= 0) {
            		// MP:̌ɂ"!"܂łIDo
            		int startPos = tmp_str.indexOf(MP_ID) + MP_ID.length();
            		String id = "";
            		if (tmp_str.indexOf(" !")>0) {
                		id = "MP_" + tmp_str.substring(startPos, tmp_str.indexOf(" !"));
            		} else {
            			id = "MP_" + tmp_str.substring(tmp_str.indexOf("MP:") + 3);
            		}
            		term.setId(id.trim());
            		if (tmp_str.indexOf("!")<0) {
                		term.setLabel("");
            		} else {
                		term.setLabel(tmp_str.substring(tmp_str.indexOf("!") + 2).trim());
            		}
            	} else if (tmp_str.indexOf(INTER_SECTION) >= 0) {
            		property = new Property();
            		property.setKind(INTER_SECTION);
            		// entity ido
            		String key = INTER_SECTION ;
            		int startPos = tmp_str.indexOf(key) + key.length();
            		// Attributeo
            		String attribute =  tmp_str.substring(startPos).trim();
            		// Attributeo
            		if (attribute.indexOf(":") > attribute.indexOf(" ")) {
            			if (attribute.indexOf(" ")>0) {
                    		property.setAttribute(attribute.substring(0, attribute.indexOf(" ")).trim());
                    		startPos = attribute.indexOf(" ");
                    		attribute =  attribute.substring(startPos).trim();
            			} else if (attribute.indexOf("_:")>=0) {
                    		property.setAttribute(attribute.substring(0, attribute.indexOf("_:")).trim());
                    		attribute =  attribute.substring(attribute.indexOf("_:") + 2).trim();
            			}
            		} else {
            			property.setAttribute("");
            		}
            		// TuTerm쐬
        			Term termSub = new Term();
        			String id = "";
        			if (attribute.indexOf("!") >= 0) {
            			id = attribute.substring(0, attribute.indexOf("!")).trim().replace(":", "_");
            			termSub.setId(id);
            			attribute = attribute.substring(attribute.indexOf("!") + 1).trim();
        			} else if (attribute.indexOf("_:")>=0) {
            			id = attribute.substring(0, attribute.indexOf("_:")).trim().replace(":", "_");
            			termSub.setId(id);
            			attribute = attribute.substring(attribute.indexOf("_:") + 2).trim();
        			}
        			termSub.setLabel(attribute);
        			property.setTerm(termSub);
        			properties.add(property);
            	}
            }
            // ŌTERMf[^Xgɒǉ
    		setTerm(term, properties);
            System.out.println("Ή\̃f[^:" + dataCnt);
            System.out.println("INPUT_DATA1:" + this.input_data1.size());
            System.out.println("INPUT_DATA2:" + this.input_data2.size());
            System.out.println("DATA_LIST:" + this.dataList.size());

    		// ^C}[I
    		timer.stop();

    		br.close();
            fr.close();

            System.out.println("ǂݍݏI");
        }
        catch(IOException e){
            e.printStackTrace();
            System.out.println("Ή\t@Co͂ŕsȏ܂D");
            System.exit(1);
        }
	}
	
	/**
	 * 
	 * Termf[^Zbgɒǉ
	 * 
	 * @param term Termw
	 * @param properties vpeB̃Xgw
	 */
	private void setTerm(Term term, List<Property> properties) {
		if (term!=null && term.getId()!=null) {
			term.setProperties(properties);
			int cnt = 0;
			// PATO ID ̌
			int patoOneCnt = 0;
			for (Property pro : term.getProperties()) {
				if (pro.getTerm().getId()!=null && pro.getTerm().getId().indexOf(PATO_ID_UNDERLINE)>=0) {
					patoOneCnt++;
				}
    			cnt++;
			}
			// PATO ID ̌tOݒ
			if (patoOneCnt==1) {
				term.setPatoOne(true);
				// f[^ZbgPƃCvbgf[^Pݒ
				String key = "";
				String[] value = new String[3];
				value[0] = term.getId();
				for (Property prop : term.getProperties()) {
					if (prop.getTerm().getId()!=null && prop.getTerm().getId().indexOf(PATO_ID_UNDERLINE)>=0) {
						key = prop.getTerm().getId();
					} else if (prop.getTerm().getId()!=null && prop.getTerm().getId().length()>0) {
						value[1] = prop.getTerm().getId();
					}
				}
				value[2] = key;
				this.data_set1.put(key + "_" + this.multiCnt, value);
				this.input_data1.add(value);
				dataList.add(term);
			} else if (patoOneCnt==2) {
				term.setPatoOne(false);
				// f[^ZbgQARƃCvbgf[^Qݒ
				String key1 = "";
				String key2 = "";
				String[] value = new String[4];
				value[0] = term.getId();
				int patoCnt = 0;
				for (Property prop : term.getProperties()) {
					if (prop.getTerm().getId()!=null && prop.getTerm().getId().indexOf(PATO_ID_UNDERLINE)>=0) {
						if (patoCnt==0) {
    						key1 = prop.getTerm().getId();
						} else {
							key2 = prop.getTerm().getId();
						}
						patoCnt++;
					} else if (prop.getTerm().getId()!=null && prop.getTerm().getId().length()>0) {
						value[1] = prop.getTerm().getId();
					}
				}
				value[2] = key1;
				value[3] = key2;
				this.data_set2.put(key1 + "_" + this.multiCnt, value);
				this.data_set3.put(key2 + "_" + this.multiCnt, value);
				this.input_data2.add(value);
				dataList.add(term);
			} else {
				System.out.println(term.getId() + " : PATOTO݂Ȃ");
				this.resultWrite(term.getId() + ", PATOTO݂Ȃ\n");
			}
			this.multiCnt++;
			//System.out.println("*******************");
		}
	}
	
	/**
	 * 
	 * ʃt@Cɏo͂
	 * 
	 * @param info ʃt@Cɏot͂wB
	 */
	private void resultWrite(String info) {
		try {
			this.resultWriter.write(info);
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
		
	}

	/**
	 * 
	 * TERMf[^擾
	 * 
	 * @param value
	 * @return TERMf[^
	 */
	private String getDescription(String[] value) {
		String desc = "";
		for (Term term : this.dataList ) {
			if (value[0].equals(term.getId())) {
				desc = "id:" + term.getId().replace("MP_", "MP:");
				desc += " ! " +term.getLabel() + "\n";
				List<Property> properties = term.getProperties();
				for (Property property : properties) {
					desc += "intersection_of:" + property.getAttribute() + " " + property.getTerm().getId().replace("PATO_", "PATO:")
					+ " ! " + property.getTerm().getLabel() +"\n";
				}
				break;
			}
		}
		return desc;
	}
}
